//
//  Controller.m
//  Stage5
//
//  Created by bill on 7/3/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import "Controller.h"
#import "MyView.h"

@implementation Controller

@synthesize albumNames;

- (id)init {
	self = [super init];
	iPhoto = [SBApplication applicationWithBundleIdentifier:@"com.apple.iPhoto"];
	return self;
}

- (NSArray *)albumNames {
	if(albumNames == nil) {
		NSMutableArray *newAlbumNames = [NSMutableArray arrayWithCapacity:[[iPhoto albums] count]];
		for(iPhotoAlbum *album in [iPhoto albums]) {
			if(album.type == iPhotoAlTyLastRollsAlbum || album.type == iPhotoAlTyTrashAlbum || 
			   album.type == iPhotoAlTyLastMonthsAlbum || album.type == iPhotoAlTyPhotoLibraryAlbum) {
				continue;
			}
			if(album.type == iPhotoAlTySmartAlbum && [album.name isEqualToString:@"Events"]) {
				continue;
			}
			// album.type == iPhotoAlTyFolderAlbum
			[newAlbumNames addObject:album.name];
		}
		albumNames = [newAlbumNames copy];
	}
	return albumNames;
}

- (NSString *)selectedAlbum {
	if(nil == selectedAlbum) {
		self.selectedAlbum = @"";
	}
	return selectedAlbum;
}

- (void)setSelectedAlbum:(NSString *)name {
	[self willChangeValueForKey:@"selectedAlbumName"];
	selectedAlbum = name;
	[self didChangeValueForKey:@"selectedAlbumName"];
	
	NSPredicate *pred = [NSPredicate predicateWithFormat:@"name = %@", selectedAlbum];
	iPhotoAlbum *album = [[[iPhoto albums] filteredArrayUsingPredicate:pred] objectAtIndex:0];
	[view addImageSublayersWithPaths:[[album photos] valueForKeyPath:@"imagePath"]];
	[view.layer setNeedsLayout];
}

@end
